package com.jiuqi.grid;

import java.io.Serializable;

public class Font implements Serializable, Cloneable
{
    public static final String DefaultFontName = "宋体";
    public static final int DefaultFontSize = 9;
    public static final int DefaultColor = 9;
    private String name;
    private int size;
    private int color;
    private int style;
    
    public Font() {
        this.name = "宋体";
        this.size = 9;
        this.color = 0;
    }
    
    public String getName() {
        return this.name;
    }
    
    public int getSize() {
        return this.size;
    }
    
    public int getColor() {
        return this.color;
    }
    
    public boolean getBold() {
        return (this.style & 0x1) > 0;
    }
    
    public boolean getItalic() {
        return (this.style & 0x2) > 0;
    }
    
    public boolean getUnderline() {
        return (this.style & 0x4) > 0;
    }
    
    public boolean getStrikeout() {
        return (this.style & 0x8) > 0;
    }
    
    public void setName(final String value) {
        this.name = ((value == null) ? this.name : value);
    }
    
    public void setSize(final int value) {
        this.size = value;
    }
    
    public void setColor(final int value) {
        this.color = value;
    }
    
    public void setBold(final boolean value) {
        if (value) {
            this.style |= 0x1;
        }
        else {
            this.style &= 0xE;
        }
    }
    
    public void setItalic(final boolean value) {
        if (value) {
            this.style |= 0x2;
        }
        else {
            this.style &= 0xD;
        }
    }
    
    public void setUnderline(final boolean value) {
        if (value) {
            this.style |= 0x4;
        }
        else {
            this.style &= 0xB;
        }
    }
    
    public void setStrikeout(final boolean value) {
        if (value) {
            this.style |= 0x8;
        }
        else {
            this.style &= 0x7;
        }
    }
    
    public int getStylevalue() {
        return this.style;
    }
    
    public void setStylevalue(final int value) {
        this.style = value;
    }
    
    @Override
    public String toString() {
        final StringBuffer result = new StringBuffer(super.toString());
        result.append("name=");
        result.append(this.name);
        result.append("size=");
        result.append(this.size);
        return result.toString();
    }
    
    public static void main(final String[] args) {
    }
}
